#include <iomanip>
#include <string.h>
#include <stdlib.h>

#include "hyperEA3_common.h"

using namespace std;


//#define	MAX 5


/*
void iso_image(const int n, const set<int>* (&op)[MAX][MAX], const int (&perm)[MAX], const set<int> *setCandidates, set<int>* (&op2)[MAX][MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++) {
		if (is_summable(op, i, j)) {
			int value = 0;
			for (set<int>::const_iterator it = op[i][j]->begin(); it != op[i][j]->end(); ++it) {
				value |= (1 << perm[ *it ]);
				op2[ perm[i] ][ perm[j] ] = &setCandidates[value];
				
			}
		}
		else {
			op2[ perm[i] ][ perm[j] ] = &setCandidates[0]; // empty set
		}
	}
}
*/





/*
set<int> compute_sum(const set<int>* (&op)[MAX][MAX], int a, int b) {
	set<int> result = set<int>();

	if (!is_summable(op, a, b))
		return result;

	else
		return *(op[a][b]);
	
}

set<int> compute_sum(const set<int>* (&op)[MAX][MAX], int a, set<int> &set_b) {
	set<int> result = set<int>();

	if (!is_summable(op, a, set_b))
		return result;


	for (set<int>::iterator it = set_b.begin(); it != set_b.end(); ++it)

		result.insert(op[a][*it]->begin(), op[a][*it]->end());
	return result;

	
}




set<int> compute_sum(const set<int>* (&op)[MAX][MAX], set<int> &set_a, set<int> &set_b) {
	set<int> result = set<int>();

	if (!is_summable(op, set_a, set_b))
		return result;

	else {
		for (set<int>::iterator it1 = set_a.begin(); it1 != set_a.end(); ++it1)
		for (set<int>::iterator it2 = set_b.begin(); it2 != set_b.end(); ++it2)

			result.insert(op[*it1][*it2]->begin(), op[*it1][*it2]->end());
		return result;
	}
	
}
*/

/*
int is_associative(const int n, const set<int> *(&op)[MAX][MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++)
	for (int k = 0; k < n; k++) {
//		cout << i << ", " << j << ", " << k << endl;

		
		// exists i+j && exists (i+j)+k => exists j+k && exists i+(j+k)
		// and (i+j)+k = i + (j+k)

		if (is_summable(op, i, j)) {
			set<int> tmp (compute_sum(op, i, j));
			if (is_summable(op, k, tmp)) {
				set<int> final1(compute_sum(op, k, tmp));

				if (!is_summable(op, j, k))
					return false;

				set<int> tmp2(compute_sum(op, j, k));

				if (!is_summable(op, i, tmp2))
					return false;

				set<int> final2(compute_sum(op, i, tmp2));

				if (final1 != final2)
					return false;
			}
		}


#

		// exists i+j && exists (i+j)+k <= exists j+k && exists i+(j+k)
		// and (i+j)+k = i + (j+k)
		if (is_summable(op, j, k)) {
			set<int> tmp(compute_sum(op, j, k));
			//cout << j << " + " << k << " = tmp: "; disp_set(tmp); cout << endl;
			if (is_summable(op, i, tmp)) {
				set<int> final1(compute_sum(op, i, tmp));
				//cout << i << " + " << "(" << j << " + " << k << " = final1:" ; disp_set(final1); cout << endl;

 

				if (!is_summable(op, i, j)) {
					//cout << "not i + j" << endl;
					return false;
				}

				set<int> tmp2(compute_sum(op, i, j));

				if (!is_summable(op, k, tmp2)) {
					//cout << "not (i+j)+k" << endl;
					return false;
				}

				//cout << "tmp2: "; disp_set(tmp2); cout << endl;
				set<int> final2(compute_sum(op, k, tmp2));
				//cout << "final2: " ;disp_set(final2); cout << endl;


				if (final1 != final2) {
					//cout << "neq" << endl;
					return false;
				}
			}
		}


	}
//	cout << "HERE" << endl;
	return true;
}
*/
bool has_unique_orthosupplement_elem(const int n, const set<int>* (&op)[MAX][MAX], int a) {
	bool found = false;

	for (int i = 0; i < n ; i++)

		if (op[a][i]->find(n - 1) != op[a][i]->end()) {
			if (!found)
				found = true;
			else
				return false; /* not unique element */
			
		}

	return found;
}

bool has_unique_orthosupplement(const int n, const set<int>* (&op)[MAX][MAX]) {
	for (int i = 0; i < n; i++)
		if (!has_unique_orthosupplement_elem(n, op, i))
			return false;

	return true;
}


/*
void disp_op(const int n, const set<int>* (&op)[MAX][MAX]) {
	for (int i = 0; i < n; i++) {

		for (int j = 0; j < n; j++) {
			cout << "{";
			disp_set(cout, n, *op[i][j]);
			cout << "}, ";
		}
		cout << endl;
			
	}
	
}
*/

void compute_complement(const int n, const set<int>* (&op)[MAX][MAX], int (&complement)[MAX]) {
/*
	cout << "computing complement for: " << endl;
	disp_op(n, op);
	cout << "end complement" << endl;
*/

//cout << "HERE" << endl;
	complement[0] = n - 1;
	complement[n - 1] = 0;

	for (int i = 1; i < n - 1; i++) {
		//cout << "c: " << i;
		for (int j = n - 2; j>=1; j--) {
		//	cout << j << " ";
			//disp_set(*op[i][j]);
			if (op[i][j]->find(n-1) != op[i][j]->end()) {
				complement[i] = j;
				break;
			}
		}
		//cout << endl;

			
		
	}
}


/*
bool is_antisymmetric(const int n, const set<int>* (&op)[MAX][MAX], const int (&complement)[MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++)
		if  (is_summable(op, i, complement[j]) && is_summable(op, j, complement[i]) && i!= j)
			return false;

	return true;
}
*/

/*
bool is_transitive(const int n, const set<int>* (&op)[MAX][MAX], const int (&complement)[MAX]) {
	for (int i = 0; i < n; i++)
	for (int j = 0; j < n; j++)
	for (int k = 0; k < n; k++)
		if  (is_summable(op, i, complement[j]) && is_summable(op, j, complement[k]) && !is_summable(op, i, complement[k]))
			return false;

	return true;
}
*/

#if 0
// initialize set with elements equal to binary representation of number i
// it is expected to call this function for i from 0 to (1 << n) - 1.
//
// n = 4
// 3210
// 0100 -> {2}
// 3210
// 1101 -> {0,2,3}

void init_set_i(set<int> &set, int i) {
	set.clear();

	int k = 0;
	while (i > 0) {
		if (i % 2)
			set.insert(k);
		
		i = i / 2;
		k++;
	}
}
#endif

bool test_subsets(const int n, const set<int> *(&op)[MAX][MAX]) {
	for (int t = 1 ; t < n; t++)
		for (set<int>::const_iterator it = op[0][t]->begin(); it != op[0][t]->end(); ++it) {
			if (*it != 0 || *it != t) {
				for (set<int>::const_iterator it2 = op[0][*it]->begin(); it2 != op[0][*it]->end(); ++it2)
					if (op[0][t]->find(*it2) == op[0][t]->end())
						return false;
			}
		}

	return true;

}

#if 0
bool test_subsets_new(const int n, int candidate, const set<int> * const (&op)[MAX][MAX], int y, const set<int> *setCandidates) {
#if 0
	for (int t = y - 1 ; t >= 0; t--) 
		if (candidate & (1<<t)) {
			/* candidate contains element t */
			for (set<int>::const_iterator it = op[0][t]->begin(); it != op[0][t]->end(); ++it) {
				/* does it contain also any element from [0][t] */
				if (!(candidate & (1 << *it))) 
					return false;

			}
		}

#endif
	for (set<int>::const_iterator it = setCandidates[candidate].begin(); it != setCandidates[candidate].end(); ++it) {
		if (*it < y) {
			for (set<int>::const_iterator it2 = op[0][ *it ]->begin(); it2 != op[0][ *it ]->end(); ++it2) {
				/* does it contain also any element from [0][*it] */
				if (setCandidates[candidate].find( *it2 ) == setCandidates[candidate].end())
					return false;
	
			}
		}
	}

	return true;

}
#endif

void solve(int x, int y, const int n, const set<int> *(&op)[MAX][MAX], int (&complement)[MAX], set<int> *setCandidates, bool transitive) {
	if (x == n - 1) {


/*
				for (int i =0 ; i < n; i++)
					cout << complement[i] << "  ";
				cout << endl;
*/

		if (hea::is_associative(n, op) /*&& has_unique_orthosupplement(n, op)*/) {
			/*int complement[MAX];*/
			/*for (int i = 0; i < n; i++)
				complement[n-1-i] = i;*/

			/*compute_complement(n, op, complement);*/

			if (hea::is_antisymmetric(n, op, complement) && 
				(!transitive || hea::is_transitive(n, op, complement))
			) 
			{
				/* display complement */
				for (int i =0 ; i < n; i++) {
					hea::disp_elem(cout, n, i);
					cout << "  ";
				}
				cout << endl;

				for (int i =0 ; i < n; i++) {
					hea::disp_elem(cout, n, complement[i]);
					cout << "  ";
				}
				cout << endl;

				hea::disp_op(cout, n, op);
				cout << "\t-M-" << endl;
			}
		}

		//disp_op(n, op);
	}
	else {
		if (x == 0) {
			/* it must be defined - excludes i = 0 */
			/* {0} cannot be used any more  - excludes i = 1 */
			for (int i = 2; i < 1 << n; i++) {
				// 1 \in 0 + 1, 1 cannot be element of 0+x for x\neq 1 
				if ( ( ((y != n - 1) && (i <= (1<<(n-1)))) || ((y == n - 1) && (i>= (1<<(n-1))))) &&



/*(y != n - 1 || i < (1 << (n - 1))) &&*/ setCandidates[i].find(y) != setCandidates[i].end()) {
					bool was_used = false;

					for (int k = y - 1; k>=1;k--) {
						if (op[0][k] == &setCandidates[i]) {
							was_used = true;	
							break;
						}
					}
					
					if (was_used)
						continue;


					/* for t = y - 1, y - 2, ... 0, if candidate for [0][y] contains t
					 * then it needs to contain all elements of [0][t] 
					 */

					if (hea::test_subsets_new(n, i, op, y, setCandidates)) {

						op[x][y] = &setCandidates[i];
						op[y][x] = &setCandidates[i];

						if (y < n - 1)
							solve(x, y + 1, n, op, complement, setCandidates, transitive);
						else {
							// test for any $t\in x + 0$, $t + 0\subseteq x + 0$
						//			if (test_subsets(n, op))
							solve(x + 1, x + 1, n, op, complement, setCandidates, transitive);
						}
						// empty set
						op[x][y] = &setCandidates[0];
						op[y][x] = &setCandidates[0];
					}

				}

			}

		}
		else {
			if (y < n - 1) {
				for (int i = 0; i < 1 << n; i++) {
					// x + y != {0}
					if (i == 1)
						continue;

				//	if (i == 0) {
						//if (is_summable(
						//if ( [all_results_are_present and is summable(x, (y+0)) ] ||
						//	[all_results_are_present and is_summable(y, (x+0)) ]
						op[x][y] = &setCandidates[i];
						if (x != y)
							op[y][x] = &setCandidates[i];

						solve(x, y + 1, n, op, complement, setCandidates, transitive);
						
						op[x][y] = &setCandidates[0];
						if (x != y)
							op[y][x] = &setCandidates[0];
				//	}
				}
			}
			else {
				// there is just one element containing 1
				int count = 0;
				for (int i = 0; i < n - 1; i++)
					if (op[x][i]->find(n - 1) != op[x][i]->end()) {
						count++;
						complement[x] = i;
					}
				if (count != 1)
					return;

				// x is summable with all elements in y + 0, if x + y is summable

				for (int i = x; i < n - 1; i++)
					if (hea::is_summable(op, x, i))
						for (set<int>::const_iterator it = op[0][i]->begin(); it != op[0][i]->end(); ++it)
							if (!hea::is_summable(op, x, *it))
								return ;

				solve(x + 1, x + 1, n, op, complement, setCandidates, transitive);
			}

		}
	}
}



int main(int argc, char **argv) {

	// solve all
	//solve(0, 1, n, op, complement, setCandidates);
	// -- solve all

	// solve for 0+1 = 1, 0+2 = 2, 0+3 = {0,3} = 9
	// solve for 0+1 = 1, 0+2 = 2, 0+3 = {1,3} = 10
	// solve for 0+1 = 1, 0+2 = 2, 0+3 = {0,1,3} = 11
	// solve for 0+1 = 1, 0+2 = 2, 0+3 = {0,2,3} = 13
/*
	op[0][1] = op[1][0] = &setCandidates[2];
	op[0][2] = op[2][0] = &setCandidates[4];
	op[0][3] = op[3][0] = &setCandidates[13];
#ifdef TRANSITIVE
	solve(0, 4, n, op, complement, setCandidates, true);
#else
	solve(0, 4, n, op, complement, setCandidates);
#endif
*/

	int  opt_n = 0;
	bool opt_transitive = false;
	int  opt_init_values[MAX*MAX];
	int  idx_init_value = 0;
	int  opt_idx;
	int  max_num_spec;
	if (argc < 2) {
		cout << "Usage: " << argv[0] << " n [-t] [init specification]" << endl <<
			"\tn\t model size (max n =  "<< MAX << ")" << endl <<
			"\t-t\t search for transitive models only"<<endl <<
			"\tinit specification\n\t\t list of integers separated by space" << endl <<
			"\t\t bit repesentation of a number means elements of set, where" << endl <<
			"\t\t lowest bit represents element 0, next bits elements a, b, c, ... " << endl <<
			"\t\t Thus, i.e. 0 means empty set, 5 = (101)_2 means set containing elements" << endl <<
			"\t\t {0, b}, etc. The values of the list corresponds to result of oplus_h " << endl <<
			"\t\t operation for (0,a), (0, b), ... (0, 1), (a, a), (a, b), ..., (a,1), ..." << endl << endl;
		return 0;
	}
	else {
		opt_n = atoi(argv[1]);
		if (opt_n < 1 || opt_n > MAX) {
			cerr << "Model size can be 1-" << MAX << endl;
			return 1;
		}

		max_num_spec = opt_n * (opt_n - 1) / 2; // maximal number of values that can be specified

		if (argc > 2) {			
			if (!strncmp("-t", argv[2], 2)) {
				opt_transitive = true;
				opt_idx = 3;
			}
			else
				opt_idx = 2;
			
			for (int i = opt_idx; i < (argc < MAX*MAX?argc:MAX*MAX); i++) {
				int temp = atoi(argv[i]); 
				if (temp < 0 || temp >= (1<<opt_n)) {
					cerr << "Invalid init specification value '" << argv[i] << "'." << endl <<
						"Value can be between 0 and " << (1<<opt_n) - 1 << "." << endl;
					 
					return 1;
				}
				
				opt_init_values[idx_init_value] = temp;
				idx_init_value++;
			}

		}

		cerr << "--------------------------------" << endl;
		cerr << "Computation summary:" << endl <<
			"  Model size: " << opt_n << " (elements: ";
		for (int i =0 ; i < opt_n - 1; i++) {
			hea::disp_elem(cerr, opt_n, i);
			cerr << ", ";
		}	
		hea::disp_elem(cerr, opt_n, opt_n - 1);
		cerr << ")" << endl <<
			"  Transitivity: " << opt_transitive << endl <<
			"  Number of prescribed elements: " << idx_init_value << endl << 
			"  List of prescibed elements: ";
		for (int i = 0; i < idx_init_value; i++)
			cerr << opt_init_values[i] << " " ;

		cerr << endl;

		if (idx_init_value > max_num_spec)
			cerr << "Warning, only " << max_num_spec << " options can be specified, the rest will be ignored." << endl; 
		
		set<int> setCandidates[1 << MAX];
		const set<int>* op[MAX][MAX];
		int complement[MAX];

		// init
		for (int i = 0; i < 1 << opt_n; i++) {
			setCandidates[i] = set<int>();
			hea::init_set_i(setCandidates[i], i);
		}
		

/*
		for (int i = 0 ; i < 1 << n; i++) {
			cout << "Set " << i << ": ";
			disp_set(setCandidates[i]);		
			cout << endl;
		}
*/
		// just to have initialize op
		for (int i = 0; i < opt_n; i++)
		for (int j = 0; j < opt_n; j++)
			op[i][j] = &setCandidates[0];
		

		// 0 + 0  = {0}
		op[0][0] = &setCandidates[1];
		// 1 + x for x != 0 is undefined
		for (int i = 1; i < opt_n; i++) {
			op[opt_n - 1][i] = &setCandidates[0];
			op[i][opt_n - 1] = &setCandidates[0];
		}

		complement[0] = opt_n - 1;
		complement[opt_n - 1] = 0;

		// init op
		int tmp_x = 0, tmp_y = 1;
		for (int i = 0; i < (idx_init_value < max_num_spec? idx_init_value:max_num_spec) ;i++) {
			if (tmp_x == 0) {
				op[tmp_x][tmp_y] = &setCandidates[ opt_init_values[i] ];
				op[tmp_y][tmp_x] = &setCandidates[ opt_init_values[i] ];
				cerr << "  ";
				hea::disp_elem(cerr, opt_n, tmp_x);
				cerr  << " + ";
				hea::disp_elem(cerr, opt_n, tmp_y);
				cerr  << " = {";
				hea::disp_set(cerr, opt_n, *op[tmp_x][tmp_y]);
				cerr << "} = ";
				hea::disp_elem(cerr, opt_n, tmp_y);
				cerr << " + ";
				hea::disp_elem(cerr, opt_n, tmp_x);
				cerr  << "." <<endl;

				if (tmp_y < opt_n - 1)
					tmp_y++;
				else {
					tmp_x++;
					tmp_y = tmp_x;
				}
			}
			else {
				op[tmp_x][tmp_y] = &setCandidates[ opt_init_values[i] ];
				cerr << "  ";
				hea::disp_elem(cerr, opt_n, tmp_x);
				cerr  << " + ";
				hea::disp_elem(cerr, opt_n, tmp_y);
				cerr  << " = {";
				hea::disp_set(cerr, opt_n, *op[tmp_x][tmp_y]);
				cerr << "}";
				if (tmp_x != tmp_y) {
					op[tmp_y][tmp_x] = &setCandidates[ opt_init_values[i] ];
					cerr << " = ";
					hea::disp_elem(cerr, opt_n, tmp_x);
					cerr  << " + ";
					hea::disp_elem(cerr, opt_n, tmp_y);
				}
				cerr << "." << endl;

				// init complement
				if (opt_init_values[i] & (1<<(opt_n-1)))
					complement[tmp_x] = tmp_y;

				if (tmp_y < opt_n - 2)
					tmp_y++;
				else {
					tmp_x++; tmp_y = tmp_x;
				}

			}
	
		}
		cerr << "--------------------------------" << endl;
		
		solve(tmp_x, tmp_y, opt_n, op, complement, setCandidates, opt_transitive);




//		cout << "\t--" << endl;



		
	}
	

			

	return 0;
}
